import { __awaiter, __rest } from '/home/arrizalamin/Work/feedloop/qore-apps/node_modules/tslib/tslib.es6.js';
import { jsx, jsxs } from '@emotion/react/jsx-runtime';
import { Text, Box as Box$1 } from '@chakra-ui/layout';
import { Box, useRadio, GridItem, Radio, Stack, Image, useRadioGroup, Grid, Menu, MenuButton, Button, MenuList, Input, MenuItem } from '@chakra-ui/react';
import * as iconsList from '@feedloop/icon';
import { ChevronDown } from '@feedloop/icon';
import * as React from 'react';
import React__default from 'react';
import { nanoid } from 'nanoid';
import { createContext as createContext$1, useContext, useContextSelector } from 'use-context-selector';
import { enablePatches, produce, applyPatches } from 'immer';
import { v4 } from 'uuid';
import { compileExpression } from 'filtrex';
import memoize from 'fast-memoize';
import dayjs from 'dayjs';
import { buildExpressionParser } from '@feedloop/expression-parser';
import { mergeConfig, javascriptConfig, evaluate as evaluate$1 } from '@feedloop/formula-editor';
import { useLocation } from 'react-router-dom';
import { QoreClient } from '@qorebase/client';
import createQoreHooks from '@qorebase/react';
import { motion } from 'framer-motion';
import '@chakra-ui/icons';
import 'react-tracking';
import { keyframes } from '@emotion/react';
import dot from '/home/arrizalamin/Work/feedloop/qore-apps/node_modules/dot-object/index.js';
import { DefaultApiFactory } from '@qorebase/sdk';
import stableHash from '/home/arrizalamin/Work/feedloop/qore-apps/node_modules/stable-hash/dist/index.js';
import useSWR from 'swr';
import { fallbackImg } from '@qorebase/app-runtime/src/utils/fallbackImage';

enablePatches();
function createContext(initialState, createActions, options = {}) {
    const Context = createContext$1({
        state: initialState,
        // eslint-disable-next-line @typescript-eslint/no-unused-vars -- for type inference
        setState: (modifier) => { },
        hasUndo: false,
        hasRedo: false,
        undo: () => { },
        redo: () => { },
        clearStack: () => { },
        // eslint-disable-next-line @typescript-eslint/no-unused-vars -- for type inference
        batchActions: (callback) => { },
        isDirty: false,
        clean: () => { },
    });
    const useContext$1 = () => useContext(Context);
    function useSelectState(selector) {
        return useContextSelector(Context, ({ state }) => selector(state));
    }
    const useActions = () => {
        const setState = useContextSelector(Context, ({ setState }) => setState);
        return React__default.useMemo(() => createActions(setState), [setState]);
    };
    const useHistory = () => useContextSelector(Context, ({ hasUndo, hasRedo, undo, redo, clearStack }) => ({
        hasUndo,
        hasRedo,
        undo,
        redo,
        clear: clearStack,
    }));
    const useBatchActions = () => useContextSelector(Context, ({ batchActions }) => batchActions);
    const useDirty = () => useContextSelector(Context, ({ isDirty, clean }) => ({ isDirty, clean }));
    const Provider = (props) => {
        var _a;
        const [state, setState] = React__default.useState((_a = props.value) !== null && _a !== void 0 ? _a : initialState);
        const [stack, setStack] = React__default.useState({
            undos: [],
            redos: [],
            batchIndex: null,
        });
        const [isDirty, setDirty] = React__default.useState(false);
        const setImmerState = React__default.useCallback((modifier, track = true) => {
            setState((state) => produce(state, modifier, (patches, inversePatches) => {
                if (patches.length === 0)
                    return;
                if (options.trackPaths &&
                    !options.trackPaths.some((trackPath) => patches.every((patch) => patch.path.join(".").startsWith(trackPath))))
                    return;
                if (track && options.trackChanges) {
                    setDirty(true);
                }
                if (options.enableHistory) {
                    setStack((stack) => {
                        return Object.assign(Object.assign({}, stack), { undos: stack.undos.concat({
                                patches,
                                inversePatches,
                            }), redos: [] });
                    });
                }
            }));
        }, []);
        const hasUndo = stack.undos.length > 0;
        const hasRedo = stack.redos.length > 0;
        const undo = React__default.useCallback(() => setStack((stack) => {
            const patchGroup = stack.undos.pop();
            if (!patchGroup)
                return stack;
            setState((state) => applyPatches(state, patchGroup.inversePatches));
            return Object.assign(Object.assign({}, stack), { redos: stack.redos.concat(patchGroup) });
        }), []);
        const redo = React__default.useCallback(() => setStack((stack) => {
            const patchGroup = stack.redos.pop();
            if (!patchGroup)
                return stack;
            setState((state) => applyPatches(state, patchGroup.patches));
            return Object.assign(Object.assign({}, stack), { undos: stack.undos.concat(patchGroup) });
        }), []);
        const batchActions = React__default.useCallback((callback) => {
            setStack((stack) => (Object.assign(Object.assign({}, stack), { batchIndex: stack.undos.length })));
            callback();
        }, []);
        React__default.useEffect(() => {
            const { undos, batchIndex } = stack;
            if (batchIndex === null)
                return;
            const batchPatchGroup = undos.slice(batchIndex).reduce((patchGroup, { patches, inversePatches }) => ({
                patches: patchGroup.patches.concat(patches),
                inversePatches: inversePatches.concat(patchGroup.inversePatches),
            }), {
                patches: [],
                inversePatches: [],
            });
            setStack({
                undos: undos.slice(0, batchIndex).concat(batchPatchGroup),
                redos: [],
                batchIndex: null,
            });
        }, [stack.batchIndex]);
        const clearStack = React__default.useCallback(() => setStack({ undos: [], redos: [], batchIndex: null }), []);
        const clean = React__default.useCallback(() => setDirty(false), []);
        const value = React__default.useMemo(() => ({
            state,
            setState: setImmerState,
            hasUndo,
            hasRedo,
            undo,
            redo,
            clearStack,
            batchActions,
            isDirty,
            clean,
        }), [state, setImmerState, stack, hasUndo, hasRedo]);
        return jsx(Context.Provider, Object.assign({ value: value }, { children: props.children }));
    };
    return {
        useContext: useContext$1,
        useSelectState,
        useActions,
        useHistory,
        useBatchActions,
        useDirty,
        Provider,
    };
}

const regex$1 = /@\[[^*]+?]\(([^*]+?)\)/gim;
const filtrexToFormula = (filtrexString) => {
    const formulaInnerString = filtrexString.replaceAll(regex$1, (match, id) => `{{${id}}}`);
    return formulaInnerString.startsWith("=")
        ? `Filtrex(${JSON.stringify(formulaInnerString.slice(1))})`
        : `"${formulaInnerString}"`;
};
const showConditionToConditionGroup = (condition) => Array.isArray(condition)
    ? {
        type: "all",
        conditions: condition.map((condition) => ({
            id: nanoid(),
            formula: `(${filtrexToFormula(condition.value)}) == (${filtrexToFormula(condition.equals)})`,
        })),
    }
    : condition;

/* eslint-disable fp/no-delete -- immer */
const Home = buildPage();
Home.type = "navigation";
const initialSchema = {
    tables: [],
    functions: [],
    views: [],
    insights: [],
    queries: [],
};
const initialApp = {
    name: "Application",
    description: "",
    icon: "",
    theme_color: "#049fdc",
    config: {
        projectID: "unknown",
        appID: "",
        endpoint: "",
        id: v4(),
        initialPage: {
            entryPage: "",
            loggedInPage: "",
        },
    },
    integrations: {},
    maps: {
        component: {
            login_component: {
                id: "login_component",
                componentID: "Login",
                options: {},
                properties: {},
                showCondition: { type: "all", conditions: [] },
                source: {
                    type: "list",
                    params: {},
                    sorts: {},
                },
                metadata: {},
            },
            register_text_input: {
                componentID: "Text Input",
                options: {},
                showCondition: { type: "all", conditions: [] },
                id: "register_text_input",
                properties: {
                    label: "Email",
                    placeholder: "Enter your email here",
                    hidden: false,
                    defaultValue: "",
                    data: {
                        inputID: "external_id",
                        field: {
                            type: "string",
                            options: {
                                format: "text",
                            },
                        },
                        validation: {
                            required: false,
                        },
                        type: "field",
                    },
                },
                source: {
                    type: "record",
                    params: {},
                    rowId: null,
                    defaultRow: { type: "first-row" },
                },
                metadata: {},
            },
            register_password_input: {
                componentID: "Password",
                options: {},
                showCondition: { type: "all", conditions: [] },
                id: "register_password_input",
                properties: {
                    title: "Password",
                    placeholder: "Enter your password here",
                    confirmPassword: true,
                    confirmTitle: "Confirm Password",
                    confirmPlaceholder: "Reenter your password here",
                    data: {
                        inputID: "password",
                        field: {
                            type: "string",
                            options: {
                                format: "text",
                            },
                        },
                        validation: {
                            required: true,
                        },
                        type: "field",
                    },
                },
                source: {
                    type: "record",
                    params: {},
                    rowId: null,
                    defaultRow: { type: "first-row" },
                },
                metadata: {},
            },
            register_role_input: {
                componentID: "Role",
                options: {},
                showCondition: { type: "all", conditions: [] },
                id: "register_role_input",
                properties: {
                    roleId: "",
                },
                source: {
                    type: "record",
                    params: {},
                    rowId: null,
                    defaultRow: { type: "first-row" },
                },
                metadata: {},
            },
            forbidden_component: {
                id: "forbidden_component",
                componentID: "Forbidden",
                options: {},
                showCondition: { type: "all", conditions: [] },
                properties: {},
                metadata: {},
                source: {
                    type: "record",
                    params: {},
                    rowId: null,
                    defaultRow: { type: "first-row" },
                },
            },
        },
        page: {
            login: Object.assign(Object.assign({}, buildPage()), { id: "login", components: [{ component: "login_component" }], type: "system", title: "Login" }),
            register: Object.assign(Object.assign({}, buildPage()), { id: "register", components: [
                    {
                        component: "register_text_input",
                    },
                    {
                        component: "register_password_input",
                    },
                    {
                        component: "register_role_input",
                    },
                ], type: "system", title: "Register", sourceID: "users", mode: "form" }),
            forbidden: Object.assign(Object.assign({}, buildPage()), { id: "forbidden", components: [{ component: "forbidden_component" }], type: "system", title: "Forbidden" }),
        },
    },
    theme: {
        id: "Light",
        options: { primaryColor: "#1890ff" },
        navigationLayout: "sidebar",
        fonts: {
            heading: ["Inter", ""],
            body: ["Inter", ""],
        },
    },
    schema: initialSchema,
    customSources: {},
    components: [],
};
const initialRuntime = {
    app: initialApp,
    control: { page: "" },
};
const RuntimeContext = createContext(initialRuntime, (modify) => {
    try {
        return {
            setTheme: (theme) => {
                modify((draft) => {
                    draft.app.theme = theme;
                });
            },
            setApp: (app) => {
                modify((draft) => {
                    var _a, _b, _c;
                    const pages = {};
                    for (const page of Object.values(app.maps.page)) {
                        if (page.id) {
                            pages[page.id] = Object.assign(Object.assign(Object.assign({}, buildPage()), page), { 
                                // @ts-ignore it was marked as "special" before
                                type: page.type === "special" ? "system" : page.type, 
                                // remove definitions property
                                properties: {
                                    values: page.properties.values,
                                }, defaultRow: page.defaultRow.type === "row-id"
                                    ? Object.assign(Object.assign({}, page.defaultRow), { rowId: page.defaultRow.rowId ||
                                            (typeof ((_a = page.params) === null || _a === void 0 ? void 0 : _a.rowId) === "string"
                                                ? (_b = page.params) === null || _b === void 0 ? void 0 : _b.rowId
                                                : "") }) : page.defaultRow, params: page.params || {
                                    rowId: ((_c = page.defaultRow) === null || _c === void 0 ? void 0 : _c.type) === "row-id"
                                        ? page.defaultRow.rowId
                                        : "",
                                } });
                        }
                    }
                    const components = Object.fromEntries(Object.entries(app.maps.component).map(([id, component]) => [
                        id,
                        Object.assign(Object.assign({}, component), { showCondition: Array.isArray(component.showCondition)
                                ? showConditionToConditionGroup(component.showCondition)
                                : component.showCondition }),
                    ]));
                    const updatedApp = Object.assign(Object.assign({}, app), { maps: Object.assign(Object.assign({}, app.maps), { page: pages, component: components }), integrations: app.integrations || {}, customSources: app.customSources || {}, theme: Object.assign(Object.assign({}, initialApp.theme), app.theme), schema: Object.assign(Object.assign({}, initialApp.schema), app.schema), components: [...initialApp.components, ...(app.components || [])] });
                    draft.app = updatedApp;
                }, false);
            },
            setIcon: (url) => {
                modify((draft) => {
                    draft.app.icon = url;
                }, false);
            },
            setControl: (control) => {
                modify((draft) => {
                    draft.control = control;
                }, false);
            },
            setInitialPage: (entryPage) => {
                modify((draft) => {
                    draft.app.config.initialPage = Object.assign(Object.assign({}, draft.app.config.initialPage), { entryPage });
                }, false);
            },
            setLoggedInPage: (loggedInPage) => {
                modify((draft) => {
                    draft.app.config.initialPage = Object.assign(Object.assign({}, draft.app.config.initialPage), { loggedInPage });
                }, false);
            },
            addNpmComponent: (name, version) => {
                modify((draft) => {
                    if (draft.app.components.find((c) => c.name === name && c.version === version)) {
                        return;
                    }
                    draft.app.components.push({
                        name,
                        version,
                        enabled: true,
                    });
                });
            },
            removeNpmComponent: (name) => {
                modify((draft) => {
                    const index = draft.app.components.findIndex((c) => c.name === name);
                    if (index !== -1) {
                        draft.app.components.splice(index, 1);
                    }
                });
            },
            setVersionNpmComponent: (name, version) => {
                modify((draft) => {
                    const index = draft.app.components.findIndex((c) => c.name === name);
                    if (index !== -1) {
                        draft.app.components[index].version = version;
                    }
                });
            },
            setEnableNpmComponent: (name, enabled) => {
                modify((draft) => {
                    const index = draft.app.components.findIndex((c) => c.name === name);
                    if (index !== -1) {
                        draft.app.components[index].enabled = enabled;
                    }
                });
            },
            reload: () => {
                modify((draft) => {
                    draft.control = { page: draft.control.page };
                });
            },
            addPage(page) {
                modify((draft) => {
                    draft.app.maps.page[page.id] = page;
                });
            },
            addIntegration(integration) {
                modify((draft) => {
                    draft.app.integrations[integration.name] = integration;
                });
            },
            setIntegrationProperty: function (namespace, field, value) {
                modify((draft) => {
                    draft.app.integrations[namespace].properties.values[field] = value;
                });
            },
            removeIntegration(namespace) {
                modify((draft) => {
                    delete draft.app.integrations[namespace];
                });
            },
            addCustomSources(externalData) {
                modify((draft) => {
                    draft.app.customSources[externalData.name] = externalData;
                });
            },
            removeCustomSources(namespace) {
                modify((draft) => {
                    delete draft.app.customSources[namespace];
                });
            },
            addComponent(component, pageRef, pageOpt) {
                modify((draft) => {
                    draft.app.maps.component[component.id] = component;
                    if (pageRef && pageOpt && typeof pageOpt.idx === "number") {
                        draft.app.maps.page[pageRef.page].components.splice(pageOpt.idx, 0, {
                            component: component.id,
                        });
                    }
                    else if (pageRef) {
                        draft.app.maps.page[pageRef.page].components.push({
                            component: component.id,
                        });
                    }
                });
            },
            addPageAndComponents(page, components) {
                modify((draft) => {
                    draft.app.maps.page[page.id] = page;
                    components.forEach((component) => {
                        draft.app.maps.component[component.id] = component;
                    });
                });
            },
            swapComponent(target, sourceIndex, destinationIndex, deletionLength = 1) {
                modify((draft) => {
                    const components = draft.app.maps.page[target.page].components;
                    const removed = components.splice(sourceIndex, deletionLength);
                    removed && components.splice(destinationIndex, 0, ...removed);
                    draft.app.maps.page[target.page].components = components;
                });
            },
            moveComponents(listUpdateComponents) {
                modify((draft) => {
                    listUpdateComponents.forEach((comp) => {
                        draft.app.maps.component[comp.id].metadata = comp.metadata;
                    });
                });
            },
            swapPage(targetPages, sourceIndex, destinationIndex) {
                modify((draft) => {
                    const pages = Object.values(draft.app.maps.page).filter((page) => page.type !== targetPages[0].type);
                    const [removed] = targetPages.splice(sourceIndex, 1);
                    removed && targetPages.splice(destinationIndex, 0, removed);
                    const newPages = pages.concat(targetPages);
                    draft.app.maps.page = newPages.reduce((reduced, page) => (Object.assign(Object.assign({}, reduced), { [page.id]: page })), {});
                });
            },
            setComponentProperty: function (target, field, value) {
                modify((draft) => {
                    draft.app.maps.component[target.component].properties[field] =
                        value;
                });
            },
            setComponentMetadata: function (target, field, value) {
                modify((draft) => {
                    if (draft.app.maps.component[target.component].metadata) {
                        draft.app.maps.component[target.component].metadata[field] =
                            value;
                    }
                    else {
                        draft.app.maps.component[target.component].metadata = {
                            [field]: value,
                        };
                    }
                });
            },
            setPageProperty: function (target, field, value) {
                modify((draft) => {
                    draft.app.maps.page[target.page].properties.values[field] = value;
                });
            },
            removeComponent(target, from, option) {
                modify((draft) => {
                    var _a;
                    if ((_a = option === null || option === void 0 ? void 0 : option.layoutDetail) === null || _a === void 0 ? void 0 : _a.componentsID) {
                        option.layoutDetail.componentsID.forEach((compId) => {
                            if (draft.app.maps.component[compId].metadata) {
                                draft.app.maps.component[compId].metadata.layout = undefined;
                            }
                            else {
                                draft.app.maps.component[compId].metadata = {};
                            }
                        });
                    }
                    const children = Object.entries(draft.app.maps.component).filter(([, value]) => value.metadata.container === target.component);
                    const childrenKeys = children.map((item) => item[0]);
                    draft.app.maps.page[from.page].components = draft.app.maps.page[from.page].components.filter((ref) => ![...childrenKeys, target.component].includes(ref.component));
                    childrenKeys.forEach((key) => {
                        delete draft.app.maps.component[key];
                    });
                    delete draft.app.maps.component[target.component];
                });
            },
            removeComponents(target, from) {
                modify((draft) => {
                    draft.app.maps.page[from.page].components = draft.app.maps.page[from.page].components.filter((ref) => !target.find((comp) => comp.component === ref.component));
                    target.forEach(({ component }) => {
                        delete draft.app.maps.component[component];
                    });
                });
            },
            removePage(target) {
                modify((draft) => {
                    const page = draft.app.maps.page[target.page];
                    for (const component of page.components) {
                        delete draft.app.maps.component[component.component];
                    }
                    delete draft.app.maps.page[target.page];
                });
            },
            setComponentSource(target, source) {
                modify((draft) => {
                    draft.app.maps.component[target.component].source = source;
                });
            },
            setComponentLayoutMetadata(target, column) {
                modify((draft) => {
                    if (!draft.app.maps.component[target.component].metadata ||
                        !draft.app.maps.component[target.component].metadata.layout)
                        return;
                    draft.app.maps.component[target.component].metadata.layout.column =
                        column;
                });
            },
            removeComponentLayoutMetadata(target) {
                modify((draft) => {
                    if (!draft.app.maps.component[target.component].metadata ||
                        !draft.app.maps.component[target.component].metadata.layout)
                        return;
                    draft.app.maps.component[target.component].metadata.layout =
                        undefined;
                });
            },
            addComponentShowCondition(target) {
                modify((draft) => {
                    if (draft.app.maps.component[target.component]) {
                        draft.app.maps.component[target.component].showCondition.conditions.push({
                            id: nanoid(),
                            formula: "true == true",
                        });
                    }
                });
            },
            updatePage(target, update) {
                modify((draft) => {
                    update(draft.app.maps.page[target.page]);
                });
            },
            updateComponentShowCondition(target, update) {
                modify((draft) => {
                    if (draft.app.maps.component[target.component]) {
                        update(draft.app.maps.component[target.component].showCondition);
                    }
                });
            },
            removeComponentShowCondition(target, index) {
                modify((draft) => {
                    if (draft.app.maps.component[target.component]) {
                        draft.app.maps.component[target.component].showCondition.conditions = draft.app.maps.component[target.component].showCondition.conditions.filter((cond, i) => i !== index);
                    }
                });
            },
            setPageTitle(target, title) {
                modify((draft) => {
                    draft.app.maps.page[target.page].title = title;
                });
            },
        };
    }
    catch (error) { }
}, { enableHistory: true, trackChanges: true, trackPaths: ["app"] });

const defineComponent = (component) => component;
// @ts-ignore
if (typeof window !== "undefined" && !window.qoreApps) {
    // @ts-ignore
    window.qoreApps = Object.assign(Object.assign({}, window.qoreApps), { registerComponent: (id, component) => ({ id, component: Object.assign({}, component) }), registerNpmComponent: (name, component) => ({ name, component }) });
}
const pageFactory = (properties) => {
    return () => ({
        components: [],
        id: nanoid(3),
        properties,
        title: "Untitled page",
        defaultRow: {
            type: "row-id",
            rowId: "",
        },
    });
};
({
    title: { type: "string", options: { format: "text" } },
    onOpen: { type: "action", options: [{ type: "none" }] },
    onScrollToBottom: { type: "action", options: [{ type: "none" }] },
    headerStyle: {
        type: "string",
        options: {
            format: "select",
            options: [
                { label: "None", value: "none" },
                { label: "General", value: "default" },
            ],
        },
    },
    action: { type: "action", options: [{ type: "none" }] },
    icon: {
        type: "string",
        options: {
            format: "icon",
            options: [
                ...Object.keys(iconsList).map((item) => ({
                    label: item,
                    value: item,
                })),
                {
                    label: "None",
                    value: "none",
                },
            ],
        },
    },
    refreshInterval: { type: "number", options: { unit: "seconds" } },
    onSuccess: { type: "action", options: [{ type: "none" }] },
});
const buildPage = pageFactory({
    values: {
        title: "New page",
        onOpen: [{ type: "none" }],
        onScrollToBottom: [{ type: "none" }],
        headerStyle: "default",
        action: [{ type: "none" }],
        icon: "none",
        refreshInterval: 0,
        onSuccess: [{ type: "none" }],
    },
});

const regex = /@\[([^*]+?)]\(([^*]+?)\)/gim;
const format = (text, data, withDisplay = false) => {
    const replaced = (text !== null && text !== void 0 ? text : "")
        .toString()
        .replace(regex, function (substring, display, id) {
        const result = data[id];
        return typeof result !== "undefined" && result !== null
            ? result
            : withDisplay
                ? display
                : "";
    });
    return replaced;
};
var format$1 = memoize(format);

const VariablesContext = React__default.createContext({
    variables: [],
    values: {},
    componentRef: undefined,
});
const useVariablesContext = () => React__default.useContext(VariablesContext);
memoize(function getVariableValue(variable, values) {
    const variableId = variable.replace(regex, function (_, display, id) {
        return id;
    });
    const result = values[variableId];
    return typeof result !== "undefined" && result !== null ? result : "";
});
const VariablesProvider = (props) => {
    const existing = useVariablesContext();
    const variables = React__default.useMemo(() => {
        return [...(props.variables || []), ...existing.variables];
    }, [props.variables, existing.variables]);
    const values = React__default.useMemo(() => {
        return Object.assign(Object.assign({}, existing.values), (props.values || {}));
    }, [props.values, existing.values]);
    const componentRef = React__default.useMemo(() => {
        return props.divElement
            ? { divElement: props.divElement }
            : existing.componentRef;
    }, [props.divElement, existing.componentRef]);
    const value = React__default.useMemo(() => ({
        variables,
        values,
        componentRef,
    }), [variables, values, componentRef]);
    return (jsx(VariablesContext.Provider, Object.assign({ value: value }, { children: props.children })));
};

const extraFunctions = {
    false: () => false,
    true: () => true,
    format_date: (format = "YYYY-MM-DD", date = new Date()) => {
        return dayjs(new Date(date)).format(format);
    },
    number: (input = 0) => {
        return Number(input);
    },
    now: (format) => {
        return dayjs().format(format);
    },
    dateDiff: (start = new Date(), end = new Date(), unit = "day") => {
        return dayjs(start).diff(end, unit);
    },
    substring: (text = "", start = 0, end = 1) => {
        return text.substring(start, end);
    },
    startsWith: (text = "", target = "", position = 0) => {
        return text.startsWith(target, position);
    },
    strlen: (input) => {
        return input.length;
    },
    bool: (input) => {
        return Boolean(input);
    },
    upper: (input) => {
        return input.toUpperCase();
    },
    lower: (input) => {
        return input.toLowerCase();
    },
    format_currency: (input, separator = ",") => {
        return `${Number(input)
            .toLocaleString("en-Us")
            .replaceAll(",", `${separator}`)}`;
    },
};

const template = (text, values) => {
    const interpolated = format$1(text, {}, true);
    try {
        if (!interpolated.startsWith("="))
            throw new Error("Not an expression");
        return compileExpression(interpolated.substring(1), {
            extraFunctions,
        })(values);
    }
    catch (error) {
        return format$1(text, values);
    }
};

const functions = [
    {
        name: "FormatDate",
        description: "format date with given formatting tokens",
        parameters: [
            {
                name: "format",
                type: "string",
                description: "string of formatting tokens",
            },
            { name: "date", type: "date", description: "date to format" },
        ],
        return: {
            type: "string",
            description: "string formatted date",
        },
        evaluate: (format, date) => dayjs(new Date(date)).format(format),
    },
    {
        name: "Filtrex",
        parameters: [
            { name: "expression", type: "string", description: "filtrex expression" },
        ],
        return: {
            type: "any",
            description: "evaluated expression",
        },
        evaluate: (expression) => evaluateExpression(expression),
    },
    {
        name: "FormatCurrency",
        description: "format number into currency with given locale and currency code",
        parameters: [
            { name: "number", type: "number" },
            {
                name: "locale",
                type: "string",
                description: "ISO 639-1 code with optional ISO 3166 code",
            },
            {
                name: "currency",
                type: "string",
                description: "ISO 4217 code",
            },
        ],
        examples: [
            'FormatCurrency(100000, "id", "IDR")',
            'FormatCurrency(100000, "en-US", "USD")',
        ],
        return: {
            type: "string",
            description: "string formatted currency",
        },
        evaluate: (number, locale, currency) => new Intl.NumberFormat(locale, {
            style: "currency",
            currency,
            currencyDisplay: "narrowSymbol",
        }).format(number),
    },
];
const operators = [];
const variables = [];
buildExpressionParser(mergeConfig(javascriptConfig, {
    functions,
    operators,
    variables,
}));
const evaluateExpression = (expression, additionalVariables = []) => {
    const parseExpression = buildExpressionParser(mergeConfig(javascriptConfig, {
        functions,
        operators,
        variables: variables.concat(additionalVariables),
    }));
    const parseResult = parseExpression(expression !== null && expression !== void 0 ? expression : "");
    if (parseResult.errors.length > 0)
        return {
            type: "error",
            errors: parseResult.errors,
        };
    try {
        return {
            type: "ok",
            result: evaluate$1(parseResult.ast, "javascript", {
                functions,
                operators,
                variables: variables.concat(additionalVariables),
            }),
        };
    }
    catch (e) {
        return { type: "ok", result: "#Error!" };
    }
};

const evaluate = (formula, values) => {
    if (typeof formula === "string")
        return template(formula, values);
    const variables = Object.entries(values).map(([name, value]) => ({
        name,
        type: "any",
        evaluate: () => value,
    }));
    const result = evaluateExpression(formula.formula, variables);
    return result.type === "ok" ? result.result : "#Error!";
};
const useEvaluate = (formula) => {
    const { values } = useVariablesContext();
    return React__default.useMemo(() => evaluate(formula, values), [formula, values]);
};

const qoreHooks = createQoreHooks(new QoreClient({
    endpoint: "",
}));
const defaultUser = { status: "idle", error: null, user: null };
const UserContext = React__default.createContext([defaultUser, () => { }]);
const UserFetcher = () => {
    const client = qore.useClient();
    const user = useCurrentUser();
    React__default.useEffect(() => {
        if (user.status === "idle") {
            user.refetch();
        }
    }, [client, user.status, user.refetch]);
    return null;
};
const QoreProvider = (props) => {
    const userContextValue = React__default.useState(defaultUser);
    const contextValue = React__default.useMemo(() => ({ client: props.value }), [props.value]);
    return (jsx(qoreHooks.context.Provider, Object.assign({ value: contextValue }, { children: jsxs(UserContext.Provider, Object.assign({ value: userContextValue }, { children: [jsx(UserFetcher, {}), props.children] })) })));
};
const useCurrentUser = () => {
    const [user, setUser] = React__default.useContext(UserContext);
    const client = qoreHooks.useClient();
    const refetch = React__default.useCallback(() => __awaiter(void 0, void 0, void 0, function* () {
        setUser((user) => (Object.assign(Object.assign({}, user), { status: "loading" })));
        const nextState = yield client
            .currentUser()
            .then((user) => {
            if (typeof user !== "object") {
                return { status: "idle", error: null, user: null };
            }
            return {
                status: "success",
                user,
                error: null,
            };
        })
            .catch((error) => ({
            status: "error",
            user: null,
            error,
        }));
        setUser(nextState);
        return nextState;
    }), [client]);
    const nextUser = React__default.useMemo(() => (Object.assign(Object.assign({}, user), { refetch })), [user, refetch]);
    return nextUser;
};
const qore = Object.assign(Object.assign({}, qoreHooks), { QoreProvider,
    useCurrentUser });
qore.useClient;

/* eslint-disable fp/no-delete -- immer */
var Panel;
(function (Panel) {
    Panel[Panel["Layout"] = 0] = "Layout";
    Panel[Panel["Navigation"] = 1] = "Navigation";
    Panel[Panel["Setting"] = 2] = "Setting";
})(Panel || (Panel = {}));
const initialEditorState = {
    activePanel: Panel.Navigation,
    schema: initialSchema,
    rightPanel: { type: "page" },
    activeWindow: "preview",
    qoreDataConfig: {
        endpoint: "",
        adminSecret: "admin-secret",
    },
    screen: "large",
    editMode: null,
    showEmptyState: {},
    hasProduction: false,
};
const EditorContext = createContext(initialEditorState, (modify) => ({
    setActivePanel(panel) {
        modify((draft) => {
            draft.activePanel = panel;
        });
    },
    setRevisionID(revisionID) {
        modify((draft) => {
            draft.revisionID = revisionID;
            draft.loaded = false;
        });
    },
    setActiveComponent(id) {
        modify((draft) => {
            draft.activeComponent = id;
        });
    },
    setActiveCategory(id) {
        modify((draft) => {
            draft.activeCategory = id;
        });
    },
    setRightPanel(name) {
        modify((draft) => {
            draft.rightPanel = name;
        });
    },
    setWindow(name) {
        modify((draft) => {
            draft.activeWindow = name;
        });
    },
    setSchema(schema) {
        modify((draft) => {
            draft.schema = schema;
            draft.loaded = true;
        });
    },
    setEditMode(mode) {
        modify((draft) => {
            draft.editMode = mode;
        });
    },
    setQoreDataConfig(config) {
        modify((draft) => {
            draft.qoreDataConfig = config;
        });
    },
    setScreen(screen) {
        modify((draft) => {
            draft.screen = screen;
        });
    },
    setShowEmptyState(id, show) {
        modify((draft) => {
            draft.showEmptyState[id] = show;
        });
    },
    setHasProduction(toggle) {
        modify((draft) => {
            draft.hasProduction = toggle;
        });
    },
}));

motion(Box);

motion(Box);
React__default.createContext({
    modalPageHistoryLength: 0,
    direction: "none",
    exitDirection: "none",
    setDirection: () => null,
    setExitDirection: () => null,
    forward: () => null,
    back: () => null,
    setModalPageHistoryLength: () => null,
});

const ToastNotificationContext = React__default.createContext({
    notification: null,
    closeNotification: () => { },
    // eslint-disable-next-line @typescript-eslint/no-unused-vars -- for createContext type inference
    triggerNotification: (messages, timeout) => { },
});
React__default.memo(function ToastNotificationContextProvider(props) {
    const [notification, setNotification] = React__default.useState(null);
    const timeoutRef = React__default.useRef(null);
    const closeNotification = React__default.useCallback(() => setNotification(null), []);
    const triggerNotification = React__default.useCallback((message, timeout = 5000) => {
        clearTimeout(timeoutRef.current);
        setNotification(message);
        timeoutRef.current = setTimeout(() => setNotification(null), timeout);
    }, []);
    const contextValue = React__default.useMemo(() => ({
        notification,
        closeNotification,
        triggerNotification,
    }), [notification, closeNotification, triggerNotification]);
    return (jsx(ToastNotificationContext.Provider, Object.assign({ value: contextValue }, { children: props.children })));
});

const EditorToastNotificationContext = React__default.createContext({
    notification: null,
    closeNotification: () => { },
    /* eslint-disable @typescript-eslint/no-unused-vars -- for createContext type inference */
    triggerNotification: (messages, timeout) => { },
    /* eslint-enable */
});
React__default.memo(function EditorToastNotificationContextProvider(props) {
    const [notification, setNotification] = React__default.useState(null);
    const timeoutRef = React__default.useRef(null);
    const closeNotification = React__default.useCallback(() => setNotification(null), []);
    const triggerNotification = React__default.useCallback((message, timeout = 5000) => {
        clearTimeout(timeoutRef.current);
        setNotification(message);
        timeoutRef.current = setTimeout(() => setNotification(null), timeout);
    }, []);
    const contextValue = React__default.useMemo(() => ({
        notification,
        closeNotification,
        triggerNotification,
    }), [notification, closeNotification, triggerNotification]);
    return (jsx(EditorToastNotificationContext.Provider, Object.assign({ value: contextValue }, { children: props.children })));
});

// This component breaks SSR
React__default.lazy(() => import('react-qr-reader'));
const QRScannerActionContext = React__default.createContext({
    showQRScanner: false,
    code: {},
    activeQRScannerId: null,
    closeQRScanner: () => { },
    triggerQRScanner: () => { },
    setQRCode: () => { },
    removeQRCode: () => { },
});
React__default.memo(function QRScannerActionContextProvider({ children, }) {
    const [state, setState] = React__default.useState({
        code: {},
        showQRScanner: false,
        activeQRScannerId: null,
    });
    const triggerQRScanner = React__default.useCallback((activeQRScannerId, metadata, onSuccessAction) => {
        setState((state) => (Object.assign(Object.assign({}, state), { showQRScanner: true, activeQRScannerId, message: (metadata === null || metadata === void 0 ? void 0 : metadata.message) || "", onSuccessAction })));
    }, []);
    const closeQRScanner = React__default.useCallback(() => {
        setState((state) => (Object.assign(Object.assign({}, state), { showQRScanner: false, activeQRScannerId: null, message: undefined, onSuccessAction: undefined })));
    }, []);
    const setQRCode = React__default.useCallback((key, code) => {
        setState((state) => (Object.assign(Object.assign({}, state), { code: Object.assign(Object.assign({}, state.code), { [key]: code }) })));
    }, []);
    const removeQRCode = React__default.useCallback((key) => {
        setState((state) => (Object.assign(Object.assign({}, state), { code: Object.assign(Object.assign({}, state.code), { [key]: null }) })));
    }, []);
    const contextValue = React__default.useMemo(() => ({
        showQRScanner: state.showQRScanner,
        code: state.code,
        activeQRScannerId: state.activeQRScannerId,
        message: state.message,
        onSuccessAction: state.onSuccessAction,
        setQRCode,
        removeQRCode,
        closeQRScanner,
        triggerQRScanner,
    }), [
        state.code,
        state.showQRScanner,
        state.activeQRScannerId,
        state.message,
        state.onSuccessAction,
        setQRCode,
        removeQRCode,
        closeQRScanner,
        triggerQRScanner,
    ]);
    return (jsx(QRScannerActionContext.Provider, Object.assign({ value: contextValue }, { children: children })));
});
function generateScanKeyframes() {
    const key = Array.from(Array(100)).reduce((key, _, i) => key.concat(`
    ${i === 0 ? "from" : i === 100 ? "to" : `${i}%`} {
      transform: translate3d(0,${i}%,0);
    }
    `), "");
    return keyframes `${key}`;
}
generateScanKeyframes();
keyframes `
  from, 20%, 53%, 80%, to {
    transform: translate3d(0,0,0);
  }

  40%, 43% {
    transform: translate3d(0, -20px, 0);
  }

  70% {
    transform: translate3d(0, -10px, 0);
  }

  90% {
    transform: translate3d(0,-4px,0);
  }
`;
keyframes `
  from {
    opacity: 0;
  }

  to {
    opacity: 1;
  }
`;

const parse = (params) => Object.fromEntries(new URLSearchParams(params).entries());

const globalListeners = new Set();
React.createContext({
    listeners: globalListeners,
    addListener: (listener) => globalListeners.add(listener),
    removeListener: (listener) => globalListeners.delete(listener),
    triggerSubmitHooks: (row) => __awaiter(void 0, void 0, void 0, function* () { return Promise.all([...globalListeners.values()].map((listener) => listener(row))); }),
});

React__default.createContext({
    type: "list",
    params: {},
    sorts: { field: "", type: "asc" },
});
React__default.createContext({
    type: "list",
    params: {},
    sorts: { field: "", type: "asc" },
});

const initialValues = {
    values: {},
    suggestions: [],
    invalidValues: {},
};
const inputFieldPrefix = "input.";
const RuntimeInputContext = createContext(initialValues, (modify) => ({
    handleChange: (key, value) => {
        modify((draft) => {
            draft.values[key] = value;
        });
    },
    setVariables(suggestions) {
        modify((draft) => {
            draft.suggestions = suggestions;
        });
    },
    setValidation: (validation) => {
        modify((draft) => {
            Object.keys(validation).forEach((key) => {
                if (typeof validation[key] === "undefined") {
                    delete draft.invalidValues[key];
                }
                else {
                    draft.invalidValues[key] = validation[key];
                }
            });
        });
    },
    resetValidation: () => {
        modify((draft) => {
            draft.invalidValues = {};
        });
    },
    resetValues: () => {
        modify((draft) => {
            draft.values = {};
        });
    },
}));
const useRuntimeInput = (data, row, config) => {
    var _a, _b, _c;
    const value = RuntimeInputContext.useSelectState((state) => {
        return state.values[inputFieldPrefix + data.inputID];
    });
    const actions = RuntimeInputContext.useActions();
    const hasChanged = React__default.useRef(false);
    const handleChange = React__default.useCallback((value) => {
        hasChanged.current = true;
        actions.handleChange(inputFieldPrefix + data.inputID, value);
    }, [data.inputID, actions.handleChange]);
    const validation = React__default.useMemo(() => {
        var _a, _b;
        const validationResult = ((_a = data.validation) === null || _a === void 0 ? void 0 : _a.required) && ((_b = config === null || config === void 0 ? void 0 : config.validate) === null || _b === void 0 ? void 0 : _b.call(config, value));
        return validationResult ? validationResult : { error: undefined };
    }, [config, (_a = data.validation) === null || _a === void 0 ? void 0 : _a.required, value]);
    const oldDataInputID = React__default.useRef(data.inputID);
    const emptyError = React__default.useMemo(() => ({ error: "" }), []);
    const produceValidationObj = React__default.useMemo(() => {
        return {
            added: (key, value) => ({ [key]: value }),
            removed: (key) => ({ [key]: undefined }),
        };
    }, []);
    React__default.useEffect(() => {
        var _a;
        actions.handleChange(inputFieldPrefix + data.inputID, config === null || config === void 0 ? void 0 : config.defaultValue);
        // make required
        if ((_a = data.validation) === null || _a === void 0 ? void 0 : _a.required) {
            actions.setValidation(produceValidationObj.added(data.inputID, emptyError));
        }
    }, []);
    React__default.useEffect(() => {
        var _a;
        if ((_a = data.validation) === null || _a === void 0 ? void 0 : _a.required) {
            if (oldDataInputID.current !== data.inputID) {
                actions.setValidation(Object.assign(Object.assign({}, produceValidationObj.removed(oldDataInputID.current)), produceValidationObj.added(data.inputID, emptyError)));
                oldDataInputID.current = data.inputID;
            }
            else {
                actions.setValidation(produceValidationObj.added(data.inputID, emptyError));
            }
        }
        else {
            actions.setValidation(produceValidationObj.removed(data.inputID));
        }
    }, [data.inputID, (_b = data.validation) === null || _b === void 0 ? void 0 : _b.required]);
    React__default.useEffect(() => {
        var _a;
        if (typeof validation.error !== "undefined" && ((_a = data.validation) === null || _a === void 0 ? void 0 : _a.required)) {
            actions.setValidation(produceValidationObj.added(data.inputID, validation));
        }
        else {
            actions.setValidation(produceValidationObj.removed(data.inputID));
        }
    }, [validation.error, data.inputID, (_c = data.validation) === null || _c === void 0 ? void 0 : _c.required]);
    React__default.useEffect(() => {
        if (!hasChanged.current && data.inputID in row && row[data.inputID]) {
            handleChange(row === null || row === void 0 ? void 0 : row[data.inputID]);
        }
    }, [row === null || row === void 0 ? void 0 : row[data.inputID], handleChange, value, config === null || config === void 0 ? void 0 : config.defaultValue]);
    React__default.useEffect(() => {
        return () => {
            actions.resetValidation();
            actions.resetValues();
        };
    }, []);
    return {
        onChange: handleChange,
        value,
        validation,
    };
};

const generateFieldName = (field, prefix = "") => field.type === "object"
    ? Object.entries(field.properties).flatMap(([fieldName, field]) => generateFieldName(field, prefix ? `${prefix}.${fieldName}` : fieldName))
    : field.type === "list"
        ? generateFieldName(field.items, `${prefix}.0`)
        : [[prefix, field.type]];
const sourceFetcher = (currentSource, source) => __awaiter(void 0, void 0, void 0, function* () {
    const valid = currentSource.params
        .filter((field) => field.required)
        .every((field) => { var _a; return ((_a = source === null || source === void 0 ? void 0 : source.params) === null || _a === void 0 ? void 0 : _a[field.slug]) !== ""; });
    if (!valid)
        return Promise.reject("some required parameter is empty");
    const params = ["GET", "OPTION"].includes(currentSource.method) && source.type === "list"
        ? `?${Object.entries((source === null || source === void 0 ? void 0 : source.params) || {})
            .map((keyValue) => keyValue.join("="))
            .join("&")}`
        : "";
    const body = ["POST", "PUT", "PATCH", "DELETE"].includes(currentSource.method)
        ? Object.keys((source === null || source === void 0 ? void 0 : source.params) || {}).reduce((formData, key) => {
            formData.append(key, source === null || source === void 0 ? void 0 : source.params[key]);
            return formData;
        }, new FormData())
        : undefined;
    const url = new URL(currentSource.host);
    return fetch([
        "/api/cors/" + url.host + url.pathname + url.search,
        currentSource.path,
        params,
    ].join(""), {
        headers: currentSource.headers,
        method: currentSource.method,
        body,
    })
        .then((resp) => resp.json())
        .then((resp) => currentSource.selector ? dot.pick(currentSource.selector, resp) : resp);
});
const openAPISourceFetcher = (source, customSource) => {
    const fields = customSource.columns.type === "object"
        ? generateFieldName(customSource.columns).map(([field, type]) => ({
            id: field,
            display: field,
            type,
        }))
        : [];
    // eslint-disable-next-line @typescript-eslint/no-unused-vars -- for type inference
    const fetch = (params) => {
        return sourceFetcher(customSource, source);
    };
    // eslint-disable-next-line @typescript-eslint/no-unused-vars -- for type inference
    const fetchList = (params) => __awaiter(void 0, void 0, void 0, function* () {
        return sourceFetcher(customSource, source).then((result) => result || []);
    });
    // eslint-disable-next-line @typescript-eslint/no-unused-vars -- for type inference
    const store = (params) => {
        return sourceFetcher(customSource, source);
    };
    // eslint-disable-next-line @typescript-eslint/no-unused-vars -- for type inference
    const notImplemeted = (params) => __awaiter(void 0, void 0, void 0, function* () { return Promise.reject(Error("not implemented")); });
    return {
        type: "openapi",
        params: customSource.params,
        inputParams: customSource.params,
        fields,
        fetch,
        fetchList,
        store,
        del: notImplemeted,
    };
};

const getRequiredParams = (table) => (table &&
    (("query" in table &&
        ("params" in table ? [] : table.query.paramsRequired)) ||
        ("insight" in table && table.params))) ||
    [];
const getRegisteredParams = (table) => (table &&
    (("query" in table &&
        ("params" in table ? table.params : table.query.registeredParams)) ||
        ("insight" in table && table.registeredParams))) ||
    {};
const tableParams = (table) => getRequiredParams(table)
    .map((param) => ({ name: param, type: "" }))
    .concat(Object.values(getRegisteredParams(table)));

const transformRow = (endpoint, view, row) => {
    const columnMap = Object.fromEntries(view.columns.map((column) => [column.name, column]) || []);
    return Object.fromEntries(Object.entries(row).map(([key, val]) => {
        var _a, _b, _c, _d;
        if (!(val && typeof val === "object" && "filename" in val))
            return [key, val];
        const column = columnMap[key];
        const tableName_ = (column === null || column === void 0 ? void 0 : column.type) === "lookup" &&
            ((_b = columnMap[(_a = column.definition) === null || _a === void 0 ? void 0 : _a.relation]) === null || _b === void 0 ? void 0 : _b.references)
            ? columnMap[(_c = column.definition) === null || _c === void 0 ? void 0 : _c.relation].references.targetTable
            : "query" in view && typeof view.query !== "string"
                ? view.query.table
                : view.name;
        const rowId = ((column === null || column === void 0 ? void 0 : column.type) === "lookup" &&
            row[(_d = column.definition) === null || _d === void 0 ? void 0 : _d.relation]) ||
            row.id;
        const columnName = ((column === null || column === void 0 ? void 0 : column.type) === "lookup" && column.definition.column) || key;
        const filePath = (column === null || column === void 0 ? void 0 : column.type) === "lookup" && val["url"]
            ? val["url"]
            : `${endpoint}/v1/files/public/${tableName_}/${rowId}/${columnName}/${
            // @ts-ignore
            val.filename}`;
        return [key, filePath];
    }));
};
const qoreSourceFetcher = (source, type, view, client, options = {}) => {
    var _a, _b, _c;
    const rowId = "rowId" in source ? source.rowId : null;
    const sdk = DefaultApiFactory({
        apiKey: client.project.config.adminSecret,
        isJsonMime: (mime) => {
            const jsonMime = new RegExp("^(application/json|[^;/ \\t]+/[^;/ \\t]+[+]json)[ \\t]*(;.*)?$", "i");
            return (mime !== null &&
                (jsonMime.test(mime) ||
                    mime.toLowerCase() === "application/json-patch+json"));
        },
        accessToken: (_b = (_a = client.project.config).getToken) === null || _b === void 0 ? void 0 : _b.call(_a),
    }, client.project.config.endpoint);
    const clientTable = type === "table"
        ? client.table(source.target || null)
        : // @ts-ignore
            client.table(((_c = view === null || view === void 0 ? void 0 : view.query) === null || _c === void 0 ? void 0 : _c.table) || "");
    const clientView = type === "table"
        ? client.table(source.target || null)
        : type === "view"
            ? client.view(source.target)
            : client.insight(source.target);
    const transformRow_ = (row) => view ? transformRow(client.project.config.endpoint, view, row) : row;
    const params = tableParams(view).map((param) => ({
        slug: param.name,
        type: param.type,
        required: true,
    })) || [];
    const inputParams = (view === null || view === void 0 ? void 0 : view.columns.map((field) => ({
        slug: field.name,
        type: field.type,
        required: true,
    }))) || [];
    const fields = (view === null || view === void 0 ? void 0 : view.columns.map((field) => ({
        id: field.name,
        display: field.name,
        type: field.type,
    })).filter((column) => {
        var _a;
        return !(type === "view" &&
            view &&
            // @ts-ignore
            !(((_a = view.query) === null || _a === void 0 ? void 0 : _a.fields) || []).includes(column.id));
    })) || [];
    const fetch = (params) => {
        const defaultRow = (source.type === "record" &&
            source.defaultRow.type === "row-id" &&
            source.defaultRow.rowId) ||
            null;
        const fetchFirstRow = source.type === "record" && source.defaultRow.type === "first-row";
        if (!(source === null || source === void 0 ? void 0 : source.target))
            return Promise.resolve({});
        switch (type) {
            case "table":
            case "view":
                return clientView
                    .readRows({
                    params: source.params,
                    condition: fetchFirstRow
                        ? undefined
                        : {
                            $and: [
                                {
                                    id: {
                                        $eq: rowId || defaultRow,
                                    },
                                },
                            ],
                        },
                    limit: 1,
                }, options)
                    .toPromise()
                    .then((data) => {
                    var _a, _b, _c, _d;
                    return (((_b = (_a = data.data) === null || _a === void 0 ? void 0 : _a.nodes) === null || _b === void 0 ? void 0 : _b[0]) && transformRow_((_d = (_c = data.data) === null || _c === void 0 ? void 0 : _c.nodes) === null || _d === void 0 ? void 0 : _d[0])) ||
                        {};
                });
            case "insight":
                return clientView
                    .readRows({
                    start: params === null || params === void 0 ? void 0 : params.start,
                    end: params === null || params === void 0 ? void 0 : params.end,
                    params: source.params,
                }, options)
                    .toPromise()
                    .then((data) => { var _a, _b; return ((_b = (_a = data.data) === null || _a === void 0 ? void 0 : _a.nodes) === null || _b === void 0 ? void 0 : _b[0]) || {}; });
            case "query":
                return sdk.query(view.name).then((data) => { var _a; return ((_a = data.data) === null || _a === void 0 ? void 0 : _a[0]) || {}; });
            default:
                return Promise.resolve({});
        }
    };
    const fetchList = (params) => {
        var _a, _b, _c;
        const sourceList = source;
        if (!(source === null || source === void 0 ? void 0 : source.target))
            return Promise.resolve([]);
        switch (type) {
            case "insight":
                return clientView
                    .readRows({
                    start: (_a = params === null || params === void 0 ? void 0 : params.start) !== null && _a !== void 0 ? _a : "",
                    end: (_b = params === null || params === void 0 ? void 0 : params.end) !== null && _b !== void 0 ? _b : "",
                    params: sourceList.params,
                }, options)
                    .toPromise()
                    .then((data) => { var _a; return ((_a = data.data) === null || _a === void 0 ? void 0 : _a.nodes) || []; });
            case "table":
            case "view":
                return clientView
                    .readRows({
                    params: sourceList.params,
                    orderBy: ((_c = sourceList.sorts) === null || _c === void 0 ? void 0 : _c.field)
                        ? {
                            [sourceList.sorts.field]: sourceList.sorts.type,
                        }
                        : undefined,
                    limit: sourceList.limit,
                    // @ts-ignore
                    offset: sourceList.offset,
                }, options)
                    .toPromise()
                    .then((data) => { var _a; return ((_a = data.data) === null || _a === void 0 ? void 0 : _a.nodes.map((row) => transformRow_(row))) || []; });
            case "query":
                return sdk.query(view.name).then((data) => data.data);
        }
    };
    const store = (params) => __awaiter(void 0, void 0, void 0, function* () {
        var _d, _e;
        const { id } = params, params_ = __rest(params, ["id"]);
        // TODO: store for view should insert to view instead of table
        const result = yield (id
            ? clientTable.updateRow(id, params_)
            : clientTable.insertRow(params_));
        return id ? result : (_e = (_d = result.results) === null || _d === void 0 ? void 0 : _d.data) === null || _e === void 0 ? void 0 : _e[0];
    });
    const del = (params) => __awaiter(void 0, void 0, void 0, function* () {
        const { id } = params;
        // TODO: store for view should insert to view instead of table
        yield clientTable.deleteRow(id);
    });
    return {
        type,
        params,
        inputParams,
        fields,
        fetch,
        fetchList,
        store,
        del,
    };
};

const useSourceHooks = (source, options) => {
    const customSource = RuntimeContext.useSelectState((state) => state.app.customSources[source.target]);
    const tables = RuntimeContext.useSelectState((state) => state.app.schema.tables);
    const views = RuntimeContext.useSelectState((state) => state.app.schema.views);
    const insights = RuntimeContext.useSelectState((state) => state.app.schema.insights);
    const queries = RuntimeContext.useSelectState((state) => state.app.schema.queries || []);
    const table = React__default.useMemo(() => tables.find((table) => table.name === source.target), [tables, source]);
    const view = React__default.useMemo(() => views.find((view) => view.name === source.target), [views, source]);
    const insight = React__default.useMemo(() => insights.find((insight) => insight.name === source.target), [insights, source]);
    const query = React__default.useMemo(() => queries.find((query) => query.name === source.target), [insights, source]);
    const client = qore.useClient();
    const sourceFetcher = React__default.useMemo(() => customSource
        ? openAPISourceFetcher(source, customSource)
        : qoreSourceFetcher(source, insight ? "insight" : view ? "view" : table ? "table" : "query", insight || view || table || query, client, options), [stableHash([customSource, table, view, source])]);
    const useFetch = (params = {}) => {
        const defaultRow = (source.type === "record" &&
            source.defaultRow.type === "row-id" &&
            source.defaultRow.rowId) ||
            null;
        const fetchFirstRow = source.type === "record" && source.defaultRow.type === "first-row";
        const isPaused = !source.target || (!fetchFirstRow && !("rowId" in source || defaultRow));
        const { data, error, isValidating, mutate } = useSWR(["fetch", source, params], () => sourceFetcher.fetch(params), {
            isPaused: () => isPaused,
            refreshInterval: options === null || options === void 0 ? void 0 : options.pollInterval,
            suspense: !isPaused && "prefetch" in source && source.prefetch,
        });
        return {
            data: data,
            error,
            status: error ? "error" : isValidating ? "loading" : "success",
            revalidate: mutate,
        };
    };
    const useFetchList = (params = {}, config) => {
        const isPaused = React__default.useMemo(() => (config === null || config === void 0 ? void 0 : config.isPaused)
            ? config.isPaused[0] === "and"
                ? !source.target && config.isPaused[1]
                : !source.target || config.isPaused[1]
            : !source.target, [source.target, config === null || config === void 0 ? void 0 : config.isPaused]);
        const basedSuspenseCondition = React__default.useMemo(() => !isPaused && "prefetch" in source && source.prefetch, [isPaused, source]);
        const suspense = React__default.useMemo(() => {
            return !!config && !!(config === null || config === void 0 ? void 0 : config.suspense)
                ? config.suspense[0] === "and"
                    ? basedSuspenseCondition && config.suspense[1]
                    : basedSuspenseCondition || config.suspense[1]
                : basedSuspenseCondition;
        }, [basedSuspenseCondition, config === null || config === void 0 ? void 0 : config.suspense]);
        const { data = [], error, isValidating, mutate, } = useSWR(["fetchList", source, params], () => sourceFetcher.fetchList(params), {
            isPaused: () => isPaused,
            refreshInterval: options === null || options === void 0 ? void 0 : options.pollInterval,
            suspense: suspense,
        });
        const location = useLocation();
        const [state, setState] = React__default.useState({
            currentSession: "closed",
            lastSession: "closed",
        });
        const isModalOpen = React__default.useMemo(() => {
            const { modalPage, modalH } = parse(location.search);
            return !!modalPage && !!modalH;
        }, [location.search]);
        const isDifferentSession = React__default.useMemo(() => state.currentSession !== state.lastSession, [state.currentSession, state.lastSession]);
        const initializeCurrentSession = React__default.useCallback(() => {
            if (isDifferentSession) {
                setState({ currentSession: "opened", lastSession: "opened" });
            }
            else if (state.currentSession === "closed") {
                setState((state) => (Object.assign(Object.assign({}, state), { currentSession: "opened" })));
            }
        }, [isDifferentSession, state.currentSession]);
        const finishedCurrentSession = React__default.useCallback(() => __awaiter(void 0, void 0, void 0, function* () {
            if (isDifferentSession) {
                yield mutate();
                setState({ currentSession: "closed", lastSession: "closed" });
            }
            else if (state.currentSession === "opened") {
                setState((state) => (Object.assign(Object.assign({}, state), { currentSession: "closed" })));
            }
        }), [isDifferentSession, state.currentSession, mutate]);
        React__default.useEffect(() => {
            if (isModalOpen) {
                initializeCurrentSession();
            }
            else if (!isModalOpen) {
                finishedCurrentSession();
            }
        }, [isModalOpen]);
        return {
            data,
            error,
            status: error
                ? "error"
                : isValidating && data.length === 0
                    ? "loading"
                    : "success",
            revalidate: mutate,
        };
    };
    const store = (params) => 
    // @ts-ignore
    sourceFetcher.store(params);
    const del = (params) => sourceFetcher.del(params);
    return {
        type: sourceFetcher.type,
        params: sourceFetcher.params,
        inputParams: sourceFetcher.inputParams,
        fields: sourceFetcher.fields,
        useFetch,
        useFetchList,
        store,
        del,
    };
};

function ListItemVariables(props) {
    const values = React__default.useMemo(() => {
        const itemIds = dot.dot(props.variables);
        return Object.fromEntries(Object.entries(itemIds).map(([key, value]) => [
            // replace array bracket syntax into dot syntax
            `item.${key.replace(/(\[|\]\.|\])/g, ".")}`,
            value,
        ]));
    }, [props.variables]);
    return (jsx(VariablesProvider, Object.assign({ values: values }, { children: props.children })));
}

React__default.createContext(() => { });

const Option = (props) => {
    const value = useEvaluate(props.properties.itemValue ||
        String(props.item.id) ||
        String(props.source.itemId));
    const label = useEvaluate(props.properties.itemLabel);
    if (String(props.dataValue) === String(value))
        props.setSelected(label);
    return (jsx(MenuItem, Object.assign({ display: !!props.search &&
            !label.toLocaleLowerCase().includes(props.search.toLocaleLowerCase())
            ? "none"
            : undefined, onClick: () => props.onChange(value), backgroundColor: String(props.dataValue) === String(value) && "gray.100" }, { children: label })));
};
const RadioItem = React__default.memo(function RadioItem(props) {
    const value = useEvaluate(props.properties.itemValue ||
        String(props.item.id) ||
        String(props.source.itemId));
    const { getInputProps, htmlProps, state, getCheckboxProps, getLabelProps } = useRadio(props.getRadioProps({ value }));
    const image = useEvaluate(props.properties.itemImage);
    const label = useEvaluate(props.properties.itemLabel);
    return (jsxs(GridItem, Object.assign({ bg: "surface.900", rounded: "md", border: "1px", borderColor: state.isChecked ? props.app.theme.options.primaryColor : "gray.200", _hover: !state.isChecked && {
            bg: "gray.200",
            borderColor: "gray.300",
        } }, { children: [props.properties.style === "text_choice" && (jsx(Radio, Object.assign({ w: "full", p: "1em", color: props.properties.style === "text_choice" && "gray.300", colorScheme: props.properties.style === "text_choice"
                    ? `var(--chakra-colors-qore-primary);`
                    : undefined }, props.getRadioProps({ value }), { children: jsx(Text, { children: label }) }))), props.properties.style === "image_choice" && (jsxs(Box$1, Object.assign({ as: "label", cursor: "pointer" }, htmlProps, { children: [jsx("input", Object.assign({}, getInputProps({}), { hidden: true })), jsxs(Stack, Object.assign({ direction: props.properties.layout === "horizontal_component"
                            ? "row"
                            : "column", alignItems: "center", justifyContent: props.properties.layout === "vertical_component" && "center", spacing: "1em", w: "full", p: "1em" }, getCheckboxProps(), { children: [props.properties.style === "image_choice" && (jsx(Image, Object.assign({ src: image, alt: label, fallbackSrc: fallbackImg, w: "64px", h: "64px", borderRadius: "md" }, getLabelProps()))), jsx(Text, Object.assign({ display: props.properties.hideLabel && "none" }, { children: label }))] }))] })))] })));
});
const CustomRadioGroup = React__default.memo(function CustomRadioGroup(props) {
    var _a;
    const { getRootProps, getRadioProps } = useRadioGroup({
        value: props.variableData.value,
        onChange: props.variableData.onChange,
    });
    return (jsx(Grid, Object.assign({ templateColumns: props.isVerticalAlign
            ? "repeat(1,1fr)"
            : {
                base: "repeat(1,1fr)",
                md: "repeat(2,1fr)",
                lg: "repeat(3,1fr)",
            }, gap: 2 }, getRootProps(), { children: (_a = props.listData) === null || _a === void 0 ? void 0 : _a.map((item) => (jsx(ListItemVariables, Object.assign({ variables: item }, { children: jsx(RadioItem, Object.assign({ item: item, dataValue: props.variableData.value, getRadioProps: getRadioProps }, props)) }), item.id))) })));
});
const DropdownListComponent = defineComponent({
    name: "Dropdown List",
    type: "list",
    icon: "SelectInput",
    group: "input",
    display: "block",
    defaultProps: {
        label: "Dropdown List",
        placeholder: "Placeholder here",
        data: {
            inputID: "Dropdown",
            field: { type: "relation", options: {} },
            validation: {
                required: false,
            },
        },
        style: "dropdown",
        itemLabel: "",
        itemImage: "",
        itemValue: "",
        verticalAlignment: false,
        hideLabel: false,
        layout: "vertical_component",
    },
    propDefinition: {
        label: { group: "Design", type: "expression", options: {} },
        placeholder: {
            group: "Design",
            type: "expression",
            options: {},
        },
        data: {
            group: "Design",
            type: "state",
            options: {
                inputID: "Input",
                field: { type: "relation", options: {} },
            },
        },
        style: {
            group: "Design",
            type: "string",
            options: {
                format: "select",
                options: [
                    {
                        label: "Dropdown",
                        value: "dropdown",
                    },
                    {
                        label: "Text Choice",
                        value: "text_choice",
                    },
                    {
                        label: "Image Choice",
                        value: "image_choice",
                    },
                ],
            },
        },
        itemLabel: {
            group: "Design",
            type: "expression",
            options: {},
            section: "dropdown",
        },
        itemImage: {
            group: "Design",
            type: "string",
            options: {
                format: "image",
            },
            section: "dropdown",
            hideOrShownOn: {
                type: "shownOn",
                expression: {
                    type: "formula",
                    formula: `style == "image_choice"`,
                },
            },
        },
        itemValue: {
            group: "Design",
            type: "expression",
            options: {},
            section: "dropdown",
        },
        verticalAlignment: {
            group: "Design",
            type: "boolean",
            options: {},
            section: "dropdown",
            hideOrShownOn: {
                type: "hideOn",
                expression: {
                    type: "formula",
                    formula: `style == "dropdown"`,
                },
            },
        },
        hideLabel: {
            group: "Design",
            type: "boolean",
            options: {},
            section: "dropdown",
            hideOrShownOn: {
                type: "shownOn",
                expression: {
                    type: "formula",
                    formula: `style == "image_choice"`,
                },
            },
        },
        layout: {
            group: "Design",
            section: "dropdown",
            hideOrShownOn: {
                type: "shownOn",
                expression: {
                    type: "formula",
                    formula: `style == "image_choice"`,
                },
            },
            type: "string",
            options: {
                format: "button",
                options: [
                    {
                        icon: "IconTopLeft",
                        value: "vertical_component",
                    },
                    {
                        icon: "IconLeft",
                        value: "horizontal_component",
                    },
                ],
            },
        },
    },
    Editor: () => __awaiter(void 0, void 0, void 0, function* () {
        return {
            data: (props) => {
                const currentPage = RuntimeContext.useSelectState((state) => state.app.maps.page[state.control.page]);
                const tables = EditorContext.useSelectState((state) => state.schema.tables);
                const views = EditorContext.useSelectState((state) => state.schema.views);
                const insights = EditorContext.useSelectState((state) => state.schema.insights);
                const tablesAndViews = React__default.useMemo(() => tables.concat(views, insights), [tables, views, insights]);
                const pageView = React__default.useMemo(() => tablesAndViews.find((view) => view.name === currentPage.sourceID), [currentPage.sourceID]);
                return (jsx(props.PropertyEditor.state, { propDef: props.propDef, propName: props.propName, value: props.value, onChange: props.onChange, view: pageView }));
            },
        };
    }),
    Component: (props) => {
        var _a;
        const boxWidth = React__default.useRef(null);
        const [selected, setSelected] = React__default.useState("");
        const [search, setSearch] = React__default.useState("");
        const sourceHooks = useSourceHooks(props.source);
        const { data: listData = [] } = sourceHooks.useFetchList();
        const title = useEvaluate(props.properties.label);
        const placeholder = useEvaluate(props.properties.placeholder);
        const data = useRuntimeInput(props.properties.data, props.data.page.row, {
            validate: (value) => {
                if (!value) {
                    return { error: "Required field, Please enter the data" };
                }
            },
        });
        const isVerticalAlign = React__default.useMemo(() => props.properties.verticalAlignment, [props.properties.verticalAlignment]);
        const styleType = React__default.useMemo(() => props.properties.style, [props.properties.style]);
        return (jsxs(Box$1, { children: [jsx(Text, Object.assign({ fontSize: "lg", pb: 2 }, { children: title })), styleType === "dropdown" && (jsxs(Menu, Object.assign({ autoSelect: false }, { children: [jsx(MenuButton, Object.assign({ as: Button, style: { border: "1px solid rgb(226, 232, 240)" }, bgColor: "surface.900", ref: boxWidth, textAlign: "left", borderRadius: "md", variant: "outline", rightIcon: jsx(ChevronDown, {}), width: "100%", _focus: { shadow: "0px" }, fontWeight: "normal", "data-test": "dropdown-list-menu-button" }, { children: data.value ? selected : placeholder })), jsxs(MenuList, Object.assign({ border: "0px", width: (_a = boxWidth === null || boxWidth === void 0 ? void 0 : boxWidth.current) === null || _a === void 0 ? void 0 : _a.offsetWidth, zIndex: 3 }, { children: [jsx(Box$1, Object.assign({ paddingX: "0.8rem" }, { children: jsx(Input, { value: search, onChange: (e) => setSearch(e.target.value), placeholder: "Search...", mb: 2, autoFocus: true }) })), jsxs(Box$1, Object.assign({ maxHeight: "11.5rem", overflowY: "auto" }, { children: [jsx(Text, Object.assign({ color: "gray", py: 2, px: 4, style: { cursor: "default" } }, { children: placeholder })), listData === null || listData === void 0 ? void 0 : listData.map((item) => (jsx(ListItemVariables, Object.assign({ variables: item }, { children: jsx(Option, Object.assign({ item: item, onChange: data.onChange, dataValue: data.value, setSelected: setSelected }, props, { "data-test": "dropdown-list-option", search: search })) }), item.id)))] }))] }))] }))), (styleType === "text_choice" || styleType === "image_choice") && (jsx(CustomRadioGroup, Object.assign({ variableData: data, listData: listData, isVerticalAlign: isVerticalAlign }, props))), !!data.validation.error && (jsx(Text, Object.assign({ fontSize: "sm", color: "red", "data-test": "text-input-error" }, { children: data.validation.error })))] }));
    },
});

export { DropdownListComponent as default };
